SystemOrganization addCategory: #'Mercury-Prototype-DebuggingSeed'!

Object subclass: #DebuggingSeed
	instanceVariableNames: ''
	classVariableNames: 'registeredRequestor'
	poolDictionaries: ''
	category: 'Mercury-Prototype-DebuggingSeed'!

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/24/2013 15:30'!
authenticate

	"authentication is automatically handled by the middleware in the prototype see: Seamless authentication manager"
	
	self loadDebuggingSupport.
	
	^ Smalltalk globals! !

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/24/2013 14:49'!
interruptedProcesses

	^ LocalDebuggerWrapper allInstances collect: [:instance | instance process]! !

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/24/2013 15:22'!
loadDebuggingSupport

	(Smalltalk globals keys includes: #RunTimeDebuggingSupport) ifFalse: [

		Gofer it
			url: 'http://ss3.gemstone.com/ss/Mercury-Prototype' username: 'nickp' password: 'drift145';
			package: 'Mercury-Prototype-RunTimeDebuggingSupport';
			load.
			
	]! !

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/24/2013 15:31'!
newUnhandledExceptionFrom: aHandler

	self loadDebuggingSupport.

	registeredRequestor ifNotNil: [registeredRequestor newRemoteException: aHandler exception].! !

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/24/2013 15:28'!
pushNewExceptionsTo: aRequestor

	registeredRequestor := aRequestor ! !

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/24/2013 14:49'!
unhandledExceptions 

	^ LocalDebuggerWrapper allInstances collect: [:instance | instance exception]! !

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/24/2013 14:32'!
unloadDebuggingSupport

	Gofer it
		package: 'Mercury-Prototype-RunTimeDebuggingSupport';
		unload.! !

Object subclass: #LocalDebuggerWrapper
	instanceVariableNames: 'aDebugger title process context exception'
	classVariableNames: 'activeInstances'
	poolDictionaries: ''
	category: 'Mercury-Prototype-DebuggingSeed'!

!LocalDebuggerWrapper class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/29/2012 01:36'!
clearDebuggees
	"send your current instances back to the client, currently"

	activeInstances := OrderedCollection new.! !

!LocalDebuggerWrapper class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/24/2010 00:56'!
getDebuggeeAt: index
	"send your current instances back to the client"

	^ activeInstances at: index.! !

!LocalDebuggerWrapper class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/29/2012 02:28'!
getDebuggees
	"send your current instances back to the client, currently"

	^ activeInstances ! !

!LocalDebuggerWrapper class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/23/2010 21:53'!
getIndexOf: aSmallDebugger
	"send your current instances back to the client, currently"

	^ activeInstances indexOf: aSmallDebugger.! !

!LocalDebuggerWrapper class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 12:44'!
initialize 
	"send your current instances back to the client, currently"

	super initialize.
	activeInstances := OrderedCollection new.! !

!LocalDebuggerWrapper class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 12/5/2010 12:11'!
removeDebuggee: aSmallDebugger

	activeInstances remove: aSmallDebugger.! !

!LocalDebuggerWrapper methodsFor: 'accessing' stamp: 'NickPapoulias 11/29/2012 01:37'!
context
	^ context! !

!LocalDebuggerWrapper methodsFor: 'accessing' stamp: 'NickPapoulias 11/29/2012 01:37'!
context: anObject
	context := anObject! !

!LocalDebuggerWrapper methodsFor: 'update' stamp: 'NickPapoulias 1/14/2013 12:54'!
currentContext

	self getStackIndex = 0 ifTrue: [^ context ] ifFalse: [ ^ aDebugger contextStack at: aDebugger contextStackIndex ]
	! !

!LocalDebuggerWrapper methodsFor: 'accessing' stamp: 'NickPapoulias 10/1/2010 15:58'!
debugger
	^ aDebugger! !

!LocalDebuggerWrapper methodsFor: 'accessing' stamp: 'NickPapoulias 10/1/2010 15:59'!
debugger: anObject
	aDebugger := anObject! !

!LocalDebuggerWrapper methodsFor: 'accessing' stamp: 'NickPapoulias 11/29/2012 01:37'!
exception
	^ exception! !

!LocalDebuggerWrapper methodsFor: 'accessing' stamp: 'NickPapoulias 1/24/2013 17:16'!
exception: anObject
	exception := anObject.
	DebuggingSeed newUnhandledExceptionFrom: self. "carefull of proper initialization"! !

!LocalDebuggerWrapper methodsFor: 'control' stamp: 'NickPapoulias 10/30/2010 21:14'!
fullStack
	"comment stating purpose of message"

	aDebugger fullyExpandStack.
	^ self getUpdate.! !

!LocalDebuggerWrapper methodsFor: 'update' stamp: 'NickPapoulias 12/5/2010 21:15'!
getCode

	^ aDebugger selectedMessage asString.! !

!LocalDebuggerWrapper methodsFor: 'update' stamp: 'NickPapoulias 12/5/2010 21:15'!
getCurrentPosition

	^ aDebugger contentsSelection.! !

!LocalDebuggerWrapper methodsFor: 'update' stamp: 'NickPapoulias 1/6/2013 09:19'!
getDictionaryForContext

	|currentContext contextArray|
	currentContext := aDebugger selectedContext activeHome.
	^ Dictionary newFrom: 
		(currentContext tempNames collect: [ :each |
		each -> (currentContext tempNamed: each) asString
	]).! !

!LocalDebuggerWrapper methodsFor: 'update' stamp: 'NickPapoulias 1/6/2013 09:20'!
getDictionaryForReceiver
	
	|receiver|
	receiver := aDebugger receiver.
	^ Dictionary newFrom: 
		(receiver class allInstVarNames collect: [ :each |
		each -> (receiver instVarNamed: each) asString
	]).! !

!LocalDebuggerWrapper methodsFor: 'update' stamp: 'NickPapoulias 12/5/2010 21:15'!
getStackIndex

	^ aDebugger contextStackIndex.! !

!LocalDebuggerWrapper methodsFor: 'update' stamp: 'NickPapoulias 11/29/2012 01:36'!
getStackList

	|contextStackList|
	contextStackList := (aDebugger contextStackList).
	^ OrderedCollection newFrom: (contextStackList collect: [:each | each asString]).! !

!LocalDebuggerWrapper methodsFor: 'update' stamp: 'NickPapoulias 1/6/2013 09:20'!
getUpdate

	^ Dictionary newFrom: {
		#StackList -> self getStackList.
		#StackIndex ->  self getStackIndex.
		#Code -> self getCode. 
		#CurrentPosition -> self getCurrentPosition.
		#ReceiverDict -> self getDictionaryForReceiver.
		#ContextDict -> self getDictionaryForContext
	}.! !

!LocalDebuggerWrapper methodsFor: 'control' stamp: 'NickPapoulias 10/3/2010 12:54'!
goToStackIndex: anIndexNumber

	aDebugger toggleContextStackIndex: anIndexNumber.
	^ self getUpdate.
	









! !

!LocalDebuggerWrapper methodsFor: 'initilization' stamp: 'NickPapoulias 1/24/2013 17:15'!
initialize

	super initialize.
	activeInstances add: self.
	"SmallServer client isNil ifFalse: [
		SmallServer client updateRequestedFrom: self.	
	]"! !

!LocalDebuggerWrapper methodsFor: 'control' stamp: 'NickPapoulias 10/30/2010 21:14'!
into
	"comment stating purpose of message"

	aDebugger stepIntoBlock.
	^ self getUpdate.! !

!LocalDebuggerWrapper methodsFor: 'control' stamp: 'NickPapoulias 11/29/2012 01:34'!
on: anError for: aProcess
	
	exception := anError.
	context := anError signalerContext.
	process := aProcess.
	self debugger: (Debugger context: context).
	! !

!LocalDebuggerWrapper methodsFor: 'control' stamp: 'NickPapoulias 10/30/2010 21:14'!
over 
	"comment stating purpose of message"

	aDebugger doStep.
	^ self getUpdate.! !

!LocalDebuggerWrapper methodsFor: 'control' stamp: 'NickPapoulias 11/29/2012 07:09'!
proceed

	aDebugger proceed.
	"LocalDebuggerWrapper removeDebuggee: aDebugger."! !

!LocalDebuggerWrapper methodsFor: 'accessing' stamp: 'NickPapoulias 11/29/2012 01:37'!
process
	^ process! !

!LocalDebuggerWrapper methodsFor: 'accessing' stamp: 'NickPapoulias 11/29/2012 01:37'!
process: anObject
	process := anObject! !

!LocalDebuggerWrapper methodsFor: 'update' stamp: 'NickPapoulias 11/29/2012 04:34'!
receiver 

	^ aDebugger receiver.! !

!LocalDebuggerWrapper methodsFor: 'control' stamp: 'NickPapoulias 10/30/2010 21:15'!
restart

	aDebugger restart.
	^ self getUpdate.! !

!LocalDebuggerWrapper methodsFor: 'control' stamp: 'NickPapoulias 10/30/2010 21:15'!
runToHere: anIntervalAsString
	"comment stating purpose of message"

	aDebugger runToSelection: (Object new readFromString: anIntervalAsString).
	^ self getUpdate.! !

!LocalDebuggerWrapper methodsFor: 'control' stamp: 'NickPapoulias 10/30/2010 21:15'!
through
	"comment stating purpose of message"

	aDebugger stepIntoBlock.
	^ self getUpdate.! !

!LocalDebuggerWrapper methodsFor: 'accessing' stamp: 'NickPapoulias 12/5/2010 15:58'!
title
	^ title! !

!LocalDebuggerWrapper methodsFor: 'accessing' stamp: 'NickPapoulias 12/5/2010 15:58'!
title: anObject
	title := anObject! !

!LocalDebuggerWrapper methodsFor: 'control' stamp: 'NickPapoulias 11/29/2012 05:09'!
toggleContextStackIndex: anInteger

	aDebugger toggleContextStackIndex: anInteger! !

!LocalDebuggerWrapper methodsFor: 'control' stamp: 'NickPapoulias 10/30/2010 21:15'!
where
	"comment stating purpose of message"

	aDebugger where.
	^ self getUpdate.! !
LocalDebuggerWrapper initialize!
